/* ===================================================================
   \[Xt@C
   =================================================================== */

/* ********************************************************** */
/* Include */
/* ********************************************************** */
#include "LedSampleApl.h"


/* ********************************************************** */
/* Structure & Define */
/* ********************************************************** */
/* ^C}[ */
typedef enum {
  LED_TIMER_STOP,
  LED_TIMER_DOING
} LED_TIMER_STATE;

/* bݒl */
#define LED_TIME       (250)  /* _/(250ms) */
#define LED_INTVAL_TIME_MS  (10) /* Interval Timer msl */


/* ********************************************************** */
/* Local Variable */
/* ********************************************************** */
static unsigned char led_apl_data;
static LED_APL_TYPE led_apl_type;
static unsigned char led_apl_req_data;
static LED_APL_TYPE led_apl_req_type;
static LED_TIMER_STATE led_timer_state;
static int led_timer_cnt;

/* ********************************************************** */
/* Local ProtoType Define */
/* ********************************************************** */
static int led_apl_is_onoff_type (LED_APL_TYPE type);
static void led_apl_set_timer (void);
static unsigned char led_apl_get_patturn (LED_APL_TYPE type, unsigned char now_led_data);

/* ================================================================== */
/* ********************************************************** */
/* Src (Internal API Function) */
/* ********************************************************** */
/* ********************************************************** */
/* Tv@F@LEDAv̏                                */
/* ֐@F@LedApl_Init                                      */
/* @F@Ȃ                                             */
/* ߂lF@Ȃ                                             */
/* ********************************************************** */
void 
LedApl_Init (void)
{
  unsigned char addr;
  unsigned char data;

  led_apl_data     = LED_ALLOFF_INIT_DAT;
  led_apl_type     = LED_TYPE_MAX;
  led_apl_req_data = LED_ALLOFF_INIT_DAT;
  led_apl_req_type = LED_TYPE_MAX;
  led_timer_state  = LED_TIMER_STOP;
  led_timer_cnt    = 0;

  /* LED o͐ݒɂ */
  addr = 0x00;
  data = 0x00;
  i2c_xfer ("MCP23017", &addr, &data, WR, sizeof(data));

  return;
}

/* ********************************************************** */
/* Tv@F@LEDʐݒ                                  */
/* ֐@F@LedApl_Set_Type                                  */
/* @F@LED_APL_TYPE type  :                     */
/*           unsigned char data : _f[^              */
/* ߂lF@Ȃ                                             */
/* ********************************************************** */
void 
LedApl_Set_Type (LED_APL_TYPE type, unsigned char data)
{
  led_apl_req_type = type;
  led_apl_req_data = data;
  return;
}


/* ********************************************************** */
/* Tv@F@LEDAv̎s                                  */
/* ֐@F@LedApl_Exec                                      */
/* @F@Ȃ                                             */
/* ߂lF@Ȃ                                             */
/* ********************************************************** */
void 
LedApl_Exec (void)
{
  unsigned char addr = 0x12;
  unsigned char out_data;

  /* ʂ̕ω or FREȄꍇ̃f[^ύXmF */
  if ((led_apl_type != led_apl_req_type) ||
	  ((led_apl_req_type == LED_TYPE_FREE) && (led_apl_data != led_apl_req_data)))
	{
	  /* UA^C}[~ */
	  led_timer_state = LED_TIMER_STOP;
	  led_timer_cnt   = 0;

	  /* ݂̐ݒlLEDݒ */
	  out_data = ~led_apl_req_data;
	  i2c_xfer ("MCP23017", &addr, &out_data, WR, sizeof(out_data));
 
	  /* S_Sł̓^C}[͎gȂ */
	  if (led_apl_is_onoff_type (led_apl_req_type) == true)
		{
		  /* ^C}[X^[g */
		  led_apl_set_timer ();
		  /* ^C}[쒆ݒ */
		  led_timer_state = LED_TIMER_DOING;
		}

	  /* \p^[ݒ */
	  led_apl_type = led_apl_req_type;
	  led_apl_data = led_apl_req_data;
	}
  else
	{
	  /* S_Sł̓^C}[͎gȂ */
	  if (led_apl_is_onoff_type (led_apl_type) == true)
		{
		  if (led_timer_state == LED_TIMER_STOP)
			{
			  /* ^C}[X^[g */
			  led_apl_set_timer ();
			  /* ^C}[쒆ݒ */
			  led_timer_state = LED_TIMER_DOING;

			  /* ̕\p^[擾 */
			  led_apl_data = led_apl_get_patturn (led_apl_type, led_apl_data);

			  /* \Jn */
			  out_data = ~led_apl_data;
			  i2c_xfer ("MCP23017", &addr, &out_data, WR, sizeof(out_data));
			}
		}
	}

  return;
}

/* ********************************************************** */
/* Tv@F@LEDAv Timer荞                          */
/* ֐@F@LedApl_Irq_Timer                                 */
/* @F@Ȃ                                             */
/* ߂lF@Ȃ                                             */
/* ********************************************************** */
void 
LedApl_Irq_Timer (void)
{
  /* S_Sł̓^C}[͎gȂ */
  if (led_apl_is_onoff_type (led_apl_type) == true)
	{
	  if (led_timer_state == LED_TIMER_DOING)
		{
		  if (led_timer_cnt <= 0)
			{
			  led_timer_state = LED_TIMER_STOP;
			}
		  else
			{
			  led_timer_cnt--;
			}
		}
	}
  return;
}


/* ================================================================== */
/* ********************************************************** */
/* Src (Local Function) */
/* ********************************************************** */

/* ************************************************************ */
/* Tv@F@LEDAv _łȂǃ^C}[KvȎʂׂ */
/* ֐@F@led_apl_is_onoff_type                              */
/* @F@LED_APL_TYPE type :                        */
/* ߂lF@true :  / false F Ȃ                        */
/* ************************************************************ */
static int 
led_apl_is_onoff_type (LED_APL_TYPE type)
{
  int ret;

  switch (type)
	{
	case LED_TYPE_ALLBLINK:	/* S_ */
	case LED_TYPE_BLINK:	/* ݓ_ */
	case LED_TYPE_SHIFT:	/* Vtg */
	case LED_TYPE_INC:		/* CNg */
	case LED_TYPE_DEC:		/* fNg */
	  ret = true;
	  break;
	case LED_TYPE_ALLOFF:	/* S */
	case LED_TYPE_ALLON:	/* S_ */
	case LED_TYPE_FREE:		/* Cӓ_ */
	default:
	  ret = false;
	  break;
	}

  return ret;
}


/* ********************************************************** */
/* Tv@F@LEDAṽ^C}[lݒ                        */
/* ֐@F@led_apl_set_timer                                */
/* @F@Ȃ                                             */
/* ߂lF@Ȃ                                             */
/* ********************************************************** */
static void 
led_apl_set_timer (void)
{
  led_timer_cnt = LED_TIME * LED_INTVAL_TIME_MS;  /* 250ms : l͎b */
  return;
}


/* ********************************************************** */
/* Tv@F@LED ̕\̎擾                           */
/* ֐@F@led_apl_get_pattern                              */
/* @F@LED_APL_TYPE type :                      */
/*           unsigned char now_led_data : ݂̕\      */
/* ߂lF@unsigned char : ̕\                     */
/* ********************************************************** */
static unsigned char 
led_apl_get_patturn (LED_APL_TYPE type, unsigned char now_led_data)
{
  unsigned char next_data;

  switch (type)
	{
	case LED_TYPE_ALLBLINK:	/* S_ */
	case LED_TYPE_BLINK:	/* ݓ_ */
	  next_data = ~(now_led_data);
	  break;
	case LED_TYPE_SHIFT:	/* Vtg */
	  next_data = (unsigned char)(now_led_data << 1);
	  if (next_data == 0)
		{
		  next_data = LED_SHIFT_INIT_DAT;
		}
	  break;
	case LED_TYPE_INC:		/* CNg */
	  next_data = (unsigned char)(now_led_data + 1);
	  break;
	case LED_TYPE_DEC:		/* fNg */
	  next_data = (unsigned char)(now_led_data - 1);
	  break;
	case LED_TYPE_ALLOFF:	/* S */
	case LED_TYPE_ALLON:	/* S_ */
	case LED_TYPE_FREE:		/* Cӓ_ */
	default:
	  next_data = now_led_data;
	  break;
	}

  return next_data;
}
